#include "game.h"
#include <stdlib.h>
#define F_CPU 16000000
#include <util/delay.h>

char categories[4][7] = {"movies", "tv", "it", "music"};
char movies[5][16] = {"iron man", "godfather", "transporter", "seven", "inception"};
char tv[5][16] = {"friends", "elementary", "suits", "house", "scrubs"};
char it[5][16] = {"avr", "c", "gcc", "simd", "linux"};
char music[5][16] = {"atb", "tiesto", "metallica", "lange", "skrillex"};
   
void main_menu()
{
   int key = -1, category = 0;
   
   while (1) { 
     if (category == 4)
	category = 0;
     else {
      if (category == -1)
	 category = 3;
     }
     LCD_print2("Choose mode:", categories[category]);
  
     key = getkey();
     
     if (key > -1)
	 PORTD |= (1 << PD7);
     else
	PORTD &= ~(1 << PD7);
     
     if (key == 8)
	category++;
     
     if (key == 2)
	category--;
     
     if (key == 5) {
	play_game(category);
	_delay_ms(2000);
	key = -1;
	category = 0;
     }
   }
}

void play_game(int mode)
{
   int key = -1, oldkey = -1, count = 0, lives = 5;
   char word[16], guessed_word[16], star[] = "****************";
   char lives_bar[] = "Lives: IIIII";
   char c;
   int found;
   char *pos;
   
   switch(mode) {
      case 0: memcpy(word, movies[rand() % 5], 16); break;
      case 1: memcpy(word,tv[rand() % 5], 16); break;
      case 2: memcpy(word, it[rand() % 5], 16); break;
      case 3: memcpy(word, music[rand() % 5], 16); break;
   }
   
   strncpy(guessed_word, star, strlen(word));
   while (lives > 0) {
      if (count > 3)
	 count = 1;
      LCD_print2(lives_bar, guessed_word);
      key = getkey();
      if (key != -1) {
	 if (oldkey != key)
	    count = 1;
	 else {
	    count++;
	 }
      } else {
	 c = get_letter(oldkey, count);
	 found = 0;
	 pos = NULL;
	 do {
	 pos = strchr(word, c);
	 guessed_word[pos - word] = c;
	 if (pos)
	    found = 1;
	 } while(pos);
      }
      if (!strchr(guessed_word, '*')) {
	 LCD_print2('You win!', ':D');
	 return;
      }
      if (!found)
	 lives--;
      _delay_ms(800);
   }
   
   LCD_print2("Game Over!", word);
}

